/*
 * Affiche une fentre remplie de petits carrs multicolores
 *
 * Auteur: Pierre Ficheux (pierre@alienor.fr)  Novembre 1999
 */
#include <stdio.h>
#include <X11/Xlib.h>

#define WIDTH	320
#define HEIGHT	250

GC	gc;
Display	*display;
int	screen;
Window	win, root;
unsigned long white_pixel, black_pixel;
Colormap cmap;

static char *color_names[] = {
    "black",
    "red",
    "green",
    "yellow",
    "blue",
    "magenta",
    "cyan",
    "white"
  };

static XColor x_colors[8];

/*
 * fonction associee a l'evenement EXPOSE 
 */
void expose ()
{
    int x, y, color = 0;

    for (x = 0 ; x < WIDTH ; x += 10) {
	for (y = 0 ; y < HEIGHT ; y += 10) {
	  XSetForeground (display, gc, x_colors[color].pixel);
	  XFillRectangle (display, win, gc, x, y, 10, 10);
	  color = (++color > 7 ? 0 : color);
	}
    }
}

/*
 * programme principal
 */
main(ac, av)
int ac;
char **av;
{
    register int i;
    XColor exact;

    if ((display = XOpenDisplay (NULL)) == NULL) {
	fprintf (stderr, "Can't open Display\n");
	exit (1);
    }

    gc = DefaultGC (display, screen);
    screen = DefaultScreen (display);
    root = RootWindow (display, screen);
    white_pixel = WhitePixel (display, screen);
    black_pixel = BlackPixel (display, screen);
    cmap = DefaultColormap(display, screen);

    win = XCreateSimpleWindow (display, root, 0, 0, WIDTH, HEIGHT, 2, black_pixel, white_pixel);
    XSelectInput (display, win , ExposureMask | KeyPressMask);

    /* Allocation des couleurs */
    for (i = 0; i != 8; i++) {
      if (!XAllocNamedColor (display, cmap, color_names[i], &x_colors[i], &exact)) {
	fprintf(stderr, "cant't alloc color %s\n", color_names[i]);
	exit (1);
      }
    }

    XMapWindow (display, win);

    for (;;) {
	XEvent ev;

	XNextEvent (display, &ev);

	switch (ev.type) {
	  case Expose :
	    expose ();
	    break;

	  case KeyPress :
	    exit (0);

	    default : break;
	}
    }
}
